#ifndef ANALISADORPDA_H
#define ANALISADORPDA_H

#include "analisador.h"

#include <cv.h>
#include <ml.h>

class AnalisadorPDA : public Analisador
{
public:
    AnalisadorPDA();
    IplImage *segmenta_fundo (IplImage *pagina);
    CvContour *encontra_produtos (IplImage *pagina, IplImage *fundo);
    CvRect recorte_rect(IplImage *pagina, CvContour *produto);
    void encontra_nomes_de_produtos (IplImage *recorte, IplImage *recorte_fundo, CvContour *produto);
private:
    IplImage *contraste;
    IplImage *linhas;
    CvKNearest *class_nomes, *class_precos;

    void detecta_linhas(IplImage *fundo);

    static const int x_sub = 100;
    static const int y_sub = 200;
    static const int h_plus = y_sub;
    static const int w_plus = x_sub + 400;


};

#endif // ANALISADORPDA_H
