#include "analisador.h"
#include "analisadorpda.h"

#include <cstdio>
#include <algorithm>
#include <cv.h>
#include <highgui.h>

int main(int argc, char *argv[])
{
    if (argc < 2) {
        printf("Passe como argumento o nome da imagem a ser analisada\n");
        return -1;
    }
    /* Carregar a imagem com imread causou problemas :S */
    IplImage *pagina = cvLoadImage(argv[1]);
    CvRect roi;        
    Analisador *pda = new AnalisadorPDA();
    IplImage *fundo = pda->segmenta_fundo(pagina);
    printf("Fundo segmentado\n");
    CvContour *produtos = pda->encontra_produtos(pagina, fundo);
    IplImage *mascara_produtos = cvCloneImage(fundo);
    cvZero(mascara_produtos);
    printf("Produtos identificados\n");
    for (CvContour *t = produtos; t != NULL; t = (CvContour *) t->h_next) {
        printf("p\n");
        cvDrawContours(mascara_produtos, (CvSeq *) t, CV_RGB(255, 255, 255), CV_RGB(255, 255, 255), -1, CV_FILLED, 8, cvPoint(0, 0));
        roi = pda->recorte_rect(pagina, t);
        cvSetImageROI(pagina, roi);
        cvSetImageROI(fundo, roi);
        IplImage *recorte = cvCreateImage(cvSize(roi.width, roi.height), pagina->depth, pagina->nChannels);
        cvCopy(pagina, recorte, NULL);
        IplImage *recorte_fundo = cvCloneImage(fundo);
        pda->encontra_nomes_de_produtos(recorte, recorte_fundo, t);
        pda->encontra_precos(pagina, t);
        cvReleaseImage(&recorte);
    }
    cvSaveImage("produtos.png", mascara_produtos, 0);
    /* recolhe resultado no final */
    return 0;
}
