#ifndef _PRODUTO_H_
#define _PRODUTO_H_

#include <cv.h>
#include <stdio.h>
#include <stdlib.h>
#include "util.h"
#include "classifier.hpp"


#ifdef __cplusplus
    extern "C" {
#endif

typedef struct _produto {
    char *nome;
    float preco;
    IplImage *regiao;
    IplImage *mascara_textos;
    float caracteristicas[8];
} Produto;

/* FUNCÇÕES PRINCIPAIS */
Produto *new_Produto (IplImage *regiao);
void produto_pre_processa(Produto *, CvKNearest *kn);
void produto_passa_ocr(Produto *);
void produto_imprime(Produto *, FILE *);
void produto_deleta(Produto *);

/* AUXILIARES */
int nome_de_produto_ou_preco (char *str);
#ifdef __cplusplus
    }
#endif

#endif
