#ifndef UTIL_H
#define UTIL_H

#include <cv.h>
#include <math.h>

#define THETA 10
#define SIGMA 10

#define BIGGER 0
#define SMALLER 1



#ifdef __cplusplus
    extern "C" {
#endif


double euclidean_distance(int r1, int b1, int g1, int r2, int b2, int g2);
double gaussian_distance(int r1, int b1, int g1, int r2, int b2, int g2, double sigma);
int pixel_at(IplImage *img, int i, int j, int c);
void set_pixel_at(IplImage *img, int i, int j, int c, int val) ;
double width_average(CvContour *cc);
double height_average(CvContour *cc);
IplImage *redimensiona_410x522(IplImage *original);
void pinta_retangulos(IplImage *img, CvContour *cc);
CvContour *connected_components(IplImage *img);
CvContour *pre_processa_cc(CvContour * cc, double wr, double hr, int cmp);

void mascara_componente_conexo(IplImage *original, CvContour *cc, IplImage * mask, IplImage *masked);
void salva_componente_conexo(IplImage *img, IplImage *mask, CvContour *cc, char *nome);

#ifdef __cplusplus
    }
#endif


#endif
